/******************************************************************************
* Copyright (c) 2016, Texas Instruments Incorporated - http://www.ti.com
*   All rights reserved.
*
*   Redistribution and use in source and binary forms, with or without
*   modification, are permitted provided that the following conditions are met:
*       * Redistributions of source code must retain the above copyright
*         notice, this list of conditions and the following disclaimer.
*       * Redistributions in binary form must reproduce the above copyright
*         notice, this list of conditions and the following disclaimer in the
*         documentation and/or other materials provided with the distribution.
*       * Neither the name of Texas Instruments Incorporated nor the
*         names of its contributors may be used to endorse or promote products
*         derived from this software without specific prior written permission.
*
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
*   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
*   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
*   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
*   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
*   THE POSSIBILITY OF SUCH DAMAGE.
*****************************************************************************/
//
//
// PCM Decoder alpha codes
//
//
//

#ifndef _PCM_A
#define _PCM_A

#include <acpbeta.h>

#define  readPCMMode 0xc200+STD_BETA_PCM,0x0400
/* Note: this should not be disabled */
#define writePCMModeEnable 0xca00+STD_BETA_PCM,0x0401

#define  readPCMRamp 0xc200+STD_BETA_PCM,0x0500
#define writePCMRampDisable 0xca00+STD_BETA_PCM,0x0500
#define writePCMRampEnable 0xca00+STD_BETA_PCM,0x0501

#define  readPCMScaleVolume 0xc200+STD_BETA_PCM,0x0600
#define writePCMScaleVolumeN(NN) 0xca00+STD_BETA_PCM,0x0600+(0xff&(NN))
#define wrotePCMScaleVolume 0xca00+STD_BETA_PCM,0x0600

#define  readPCMLFEDownmixVolume 0xc200+STD_BETA_PCM,0x0700
#define writePCMLFEDownmixVolumeN(NN) 0xca00+STD_BETA_PCM,0x0700+(0xff&(NN))
/* in support of inverse compilation only */
#define writePCMLFEDownmixVolumeN__20__ writePCMLFEDownmixVolumeN(20) 

#define  readPCMChannelConfigurationProgram 0xc600+STD_BETA_PCM,0x1808
#define writePCMChannelConfigurationProgramUnknown 0xce00+STD_BETA_PCM,0x1808,0x0000,0x0000,0x0000,0x0000

#define writePCMChannelConfigurationProgramNone       writePCMChannelConfigurationProgramNone_0 
#define writePCMChannelConfigurationProgramMono       writePCMChannelConfigurationProgramMono_0 
#define writePCMChannelConfigurationProgramStereo     writePCMChannelConfigurationProgramPhantom0_0 
#define writePCMChannelConfigurationProgramStereoLtRt writePCMChannelConfigurationProgramPhantom0LtRt_0 
#define writePCMChannelConfigurationProgramStereoMono writePCMChannelConfigurationProgramPhantom0Mono_0 
#define writePCMChannelConfigurationProgram3Stereo    writePCMChannelConfigurationProgramSurround0_1 
#define writePCMChannelConfigurationProgramPhantom    writePCMChannelConfigurationProgramPhantom2_1 
#define writePCMChannelConfigurationProgramSurround   writePCMChannelConfigurationProgramSurround2_1 

#define writePCMChannelConfigurationProgramNone_0 0xce00+STD_BETA_PCM,0x1808,0x0001,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramMono_0 0xce00+STD_BETA_PCM,0x1808,0x0002,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0_0 0xce00+STD_BETA_PCM,0x1808,0x0003,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Stereo_0 0xce00+STD_BETA_PCM,0x1808,0x0003,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LtRt_0 0xce00+STD_BETA_PCM,0x1808,0x0003,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Mono_0 0xce00+STD_BETA_PCM,0x1808,0x0003,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Dual_0 0xce00+STD_BETA_PCM,0x1808,0x0003,0x0004,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom1_0 0xce00+STD_BETA_PCM,0x1808,0x0004,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2_0 0xce00+STD_BETA_PCM,0x1808,0x0005,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2Stereo_0 0xce00+STD_BETA_PCM,0x1808,0x0005,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LtRt_0 0xce00+STD_BETA_PCM,0x1808,0x0005,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2Mono_0 0xce00+STD_BETA_PCM,0x1808,0x0005,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom3_0 0xce00+STD_BETA_PCM,0x1808,0x0006,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom4_0 0xce00+STD_BETA_PCM,0x1808,0x0007,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround0_0 0xce00+STD_BETA_PCM,0x1808,0x1808,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround1_0 0xce00+STD_BETA_PCM,0x1808,0x0009,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2_0 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2Stereo_0 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LtRt_0 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2Mono_0 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround3_0 0xce00+STD_BETA_PCM,0x1808,0x000b,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround4_0 0xce00+STD_BETA_PCM,0x1808,0x000c,0x0000,0x0000,0x0000

#define writePCMChannelConfigurationProgramNone_1 0xce00+STD_BETA_PCM,0x1808,0x0101,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramMono_1 0xce00+STD_BETA_PCM,0x1808,0x0102,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0_1 0xce00+STD_BETA_PCM,0x1808,0x0103,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Stereo_1 0xce00+STD_BETA_PCM,0x1808,0x0103,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LtRt_1 0xce00+STD_BETA_PCM,0x1808,0x0103,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Mono_1 0xce00+STD_BETA_PCM,0x1808,0x0103,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Dual_1 0xce00+STD_BETA_PCM,0x1808,0x0103,0x0004,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom1_1 0xce00+STD_BETA_PCM,0x1808,0x0104,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2_1 0xce00+STD_BETA_PCM,0x1808,0x0105,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2Stereo_1 0xce00+STD_BETA_PCM,0x1808,0x0105,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LtRt_1 0xce00+STD_BETA_PCM,0x1808,0x0105,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2Mono_1 0xce00+STD_BETA_PCM,0x1808,0x0105,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom3_1 0xce00+STD_BETA_PCM,0x1808,0x0106,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom4_1 0xce00+STD_BETA_PCM,0x1808,0x0107,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround0_1 0xce00+STD_BETA_PCM,0x1808,0x0108,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround1_1 0xce00+STD_BETA_PCM,0x1808,0x0109,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2_1 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2Stereo_1 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LtRt_1 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2Mono_1 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround3_1 0xce00+STD_BETA_PCM,0x1808,0x010b,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround4_1 0xce00+STD_BETA_PCM,0x1808,0x010c,0x0000,0x0000,0x0000

#define writePCMChannelConfigurationProgramNone_2 0xce00+STD_BETA_PCM,0x1808,0x0201,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramMono_2 0xce00+STD_BETA_PCM,0x1808,0x0202,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0_2 0xce00+STD_BETA_PCM,0x1808,0x0203,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Stereo_2 0xce00+STD_BETA_PCM,0x1808,0x0203,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LtRt_2 0xce00+STD_BETA_PCM,0x1808,0x0203,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Mono_2 0xce00+STD_BETA_PCM,0x1808,0x0203,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0Dual_2 0xce00+STD_BETA_PCM,0x1808,0x0203,0x0004,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom1_2 0xce00+STD_BETA_PCM,0x1808,0x0204,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2_2 0xce00+STD_BETA_PCM,0x1808,0x0205,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2Stereo_2 0xce00+STD_BETA_PCM,0x1808,0x0205,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LtRt_2 0xce00+STD_BETA_PCM,0x1808,0x0205,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2Mono_2 0xce00+STD_BETA_PCM,0x1808,0x0205,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom3_2 0xce00+STD_BETA_PCM,0x1808,0x0206,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom4_2 0xce00+STD_BETA_PCM,0x1808,0x0207,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround0_2 0xce00+STD_BETA_PCM,0x1808,0x0208,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround1_2 0xce00+STD_BETA_PCM,0x1808,0x0209,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2_2 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2Stereo_2 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LtRt_2 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0002,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2Mono_2 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0003,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround3_2 0xce00+STD_BETA_PCM,0x1808,0x020b,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround4_2 0xce00+STD_BETA_PCM,0x1808,0x020c,0x0000,0x0000,0x0000

#define writePCMChannelConfigurationProgramStereoUnknown 0xce00+STD_BETA_PCM,0x1808,0x0003,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramStereoStereo 0xce00+STD_BETA_PCM,0x1808,0x0003,0x0001,0x0000,0x0000
#define writePCMChannelConfigurationProgramStereoDual 0xce00+STD_BETA_PCM,0x1808,0x0003,0x0004,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2Unknown_0 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2Unknown_1 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0000,0x0000,0x0000

// Extended channel configuration requests

#define writePCMChannelConfigurationProgramNoneX(n) 0xce00+STD_BETA_PCM,0x1808,0x0001,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramNoneLwRw writePCMChannelConfigurationProgramNoneX(0x01)
#define writePCMChannelConfigurationProgramNoneLhRh writePCMChannelConfigurationProgramNoneX(0x04)
#define writePCMChannelConfigurationProgramNoneLwRwLhRh writePCMChannelConfigurationProgramNoneX(0x05)
#define writePCMChannelConfigurationProgramMonoX(n) 0xce00+STD_BETA_PCM,0x1808,0x0002,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramMonoLwRw writePCMChannelConfigurationProgramMonoX(0x01)
#define writePCMChannelConfigurationProgramMonoLhRh writePCMChannelConfigurationProgramMonoX(0x04)
#define writePCMChannelConfigurationProgramMonoLwRwLhRh writePCMChannelConfigurationProgramMonoX(0x05)
#define writePCMChannelConfigurationProgramStereoX(n) 0xce00+STD_BETA_PCM,0x1808,0x0003,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramStereoLwRw writePCMChannelConfigurationProgramStereoX(0x01)
#define writePCMChannelConfigurationProgramStereoLhRh writePCMChannelConfigurationProgramStereoX(0x04)
#define writePCMChannelConfigurationProgramStereoLwRwLhRh writePCMChannelConfigurationProgramStereoX(0x05)
#define writePCMChannelConfigurationProgramStereoXLtRt(n) 0xce00+STD_BETA_PCM,0x1808,0x0003,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramStereoLwRwLtRt writePCMChannelConfigurationProgramStereoXLtRt(0x01)
#define writePCMChannelConfigurationProgramStereoLhRhLtRt writePCMChannelConfigurationProgramStereoXLtRt(0x04)
#define writePCMChannelConfigurationProgramStereoLwRwLhRhLtRt writePCMChannelConfigurationProgramStereoXLtRt(0x05)
#define writePCMChannelConfigurationProgramStereoXMono(n) 0xce00+STD_BETA_PCM,0x1808,0x0003,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramStereoLwRwMono writePCMChannelConfigurationProgramStereoXMono(0x01)
#define writePCMChannelConfigurationProgramStereoLhRhMono writePCMChannelConfigurationProgramStereoXMono(0x04)
#define writePCMChannelConfigurationProgramStereoLwRwLhRhMono writePCMChannelConfigurationProgramStereoXMono(0x05)
#define writePCMChannelConfigurationProgram3StereoX(n) 0xce00+STD_BETA_PCM,0x1808,0x0108,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgram3StereoLwRw writePCMChannelConfigurationProgram3StereoX(0x01)
#define writePCMChannelConfigurationProgram3StereoLhRh writePCMChannelConfigurationProgram3StereoX(0x04)
#define writePCMChannelConfigurationProgram3StereoLwRwLhRh writePCMChannelConfigurationProgram3StereoX(0x05)
#define writePCMChannelConfigurationProgramPhantomX(n) 0xce00+STD_BETA_PCM,0x1808,0x0105,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantomLwRw writePCMChannelConfigurationProgramPhantomX(0x01)
#define writePCMChannelConfigurationProgramPhantomLhRh writePCMChannelConfigurationProgramPhantomX(0x04)
#define writePCMChannelConfigurationProgramPhantomLwRwLhRh writePCMChannelConfigurationProgramPhantomX(0x05)
#define writePCMChannelConfigurationProgramSurroundX(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurroundLwRw writePCMChannelConfigurationProgramSurroundX(0x01)
#define writePCMChannelConfigurationProgramSurroundLhRh writePCMChannelConfigurationProgramSurroundX(0x04)
#define writePCMChannelConfigurationProgramSurroundLwRwLhRh writePCMChannelConfigurationProgramSurroundX(0x05)

// _0
#define writePCMChannelConfigurationProgramNoneX_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0001,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramNoneLwRw_0 writePCMChannelConfigurationProgramNoneX_0(0x01)
#define writePCMChannelConfigurationProgramNoneLhRh_0 writePCMChannelConfigurationProgramNoneX_0(0x04)
#define writePCMChannelConfigurationProgramNoneLwRwLhRh_0 writePCMChannelConfigurationProgramNoneX_0(0x05)
#define writePCMChannelConfigurationProgramMonoX_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0002,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramMonoLwRw_0 writePCMChannelConfigurationProgramMonoX_0(0x01)
#define writePCMChannelConfigurationProgramMonoLhRh_0 writePCMChannelConfigurationProgramMonoX_0(0x04)
#define writePCMChannelConfigurationProgramMonoLwRwLhRh_0 writePCMChannelConfigurationProgramMonoX_0(0x05)
#define writePCMChannelConfigurationProgramPhantom0X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0003,(n<<8)0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRw_0 writePCMChannelConfigurationProgramPhantom0X_0(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRh_0 writePCMChannelConfigurationProgramPhantom0X_0(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRh_0 writePCMChannelConfigurationProgramPhantom0X_0(0x05)
#define writePCMChannelConfigurationProgramPhantom0XStereo_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0003,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwStereo_0 writePCMChannelConfigurationProgramPhantom0XStereo_0(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhStereo_0 writePCMChannelConfigurationProgramPhantom0XStereo_0(0x04) 
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhStereo_0 writePCMChannelConfigurationProgramPhantom0XStereo_0(0x05) 
#define writePCMChannelConfigurationProgramPhantom0XLtRt_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0003,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwLtRt_0 writePCMChannelConfigurationProgramPhantom0XLtRt_0(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhLtRt_0 writePCMChannelConfigurationProgramPhantom0XLtRt_0(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhLtRt_0 writePCMChannelConfigurationProgramPhantom0XLtRt_0(0x05)
#define writePCMChannelConfigurationProgramPhantom0XMono_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0003,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwMono_0 writePCMChannelConfigurationProgramPhantom0XMono_0(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhMono_0 writePCMChannelConfigurationProgramPhantom0XMono_0(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhMono_0 writePCMChannelConfigurationProgramPhantom0XMono_0(0x05)
#define writePCMChannelConfigurationProgramPhantom0XDual_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0003,((n<<8)|0x0004),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwDual_0 writePCMChannelConfigurationProgramPhantom0XDual_0(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhDual_0 writePCMChannelConfigurationProgramPhantom0XDual_0(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhDual_0 writePCMChannelConfigurationProgramPhantom0XDual_0(0x05)
#define writePCMChannelConfigurationProgramPhantom1X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0004,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom1LwRw_0 writePCMChannelConfigurationProgramPhantom1X_0(0x01)
#define writePCMChannelConfigurationProgramPhantom1LhRh_0 writePCMChannelConfigurationProgramPhantom1X_0(0x04)
#define writePCMChannelConfigurationProgramPhantom1LwRwLhRh_0 writePCMChannelConfigurationProgramPhantom1X_0(0x05)
#define writePCMChannelConfigurationProgramPhantom2X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0005,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRw_0 writePCMChannelConfigurationProgramPhantom2X_0(0x01)
#define writePCMChannelConfigurationProgramPhantom2LhRh_0 writePCMChannelConfigurationProgramPhantom2X_0(0x04)
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRh_0 writePCMChannelConfigurationProgramPhantom2X_0(0x05)
#define writePCMChannelConfigurationProgramPhantom2XStereo_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0005,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwStereo_0 writePCMChannelConfigurationProgramPhantom2XStereo_0(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhStereo_0 writePCMChannelConfigurationProgramPhantom2XStereo_0(0x04) 
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhStereo_0 writePCMChannelConfigurationProgramPhantom2XStereo_0(0x05) 
#define writePCMChannelConfigurationProgramPhantom2XLtRt_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0005,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwLtRt_0 writePCMChannelConfigurationProgramPhantom2XLtRt_0(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhLtRt_0 writePCMChannelConfigurationProgramPhantom2XLtRt_0(0x04) 
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhLtRt_0 writePCMChannelConfigurationProgramPhantom2XLtRt_0(0x05) 
#define writePCMChannelConfigurationProgramPhantom2XMono_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0005,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwMono_0 writePCMChannelConfigurationProgramPhantom2XMono_0(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhMono_0 writePCMChannelConfigurationProgramPhantom2XMono_0(0x04)
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhMono_0 writePCMChannelConfigurationProgramPhantom2XMono_0(0x05) 
#define writePCMChannelConfigurationProgramPhantom3X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0006,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom3LwRw_0 writePCMChannelConfigurationProgramPhantom3X_0(0x01)
#define writePCMChannelConfigurationProgramPhantom3LhRh_0 writePCMChannelConfigurationProgramPhantom3X_0(0x04)
#define writePCMChannelConfigurationProgramPhantom3LwRwLhRh_0 writePCMChannelConfigurationProgramPhantom3X_0(0x05)
#define writePCMChannelConfigurationProgramPhantom4X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0007,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom4LwRw_0 writePCMChannelConfigurationProgramPhantom4X_0(0x01)
#define writePCMChannelConfigurationProgramPhantom4LhRh_0 writePCMChannelConfigurationProgramPhantom4X_0(0x04)
#define writePCMChannelConfigurationProgramPhantom4LwRwLhRh_0 writePCMChannelConfigurationProgramPhantom4X_0(0x05)
#define writePCMChannelConfigurationProgramSurround0X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0008,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround0LwRw_0 writePCMChannelConfigurationProgramSurround0X_0(0x01)
#define writePCMChannelConfigurationProgramSurround0LhRh_0 writePCMChannelConfigurationProgramSurround0X_0(0x04)
#define writePCMChannelConfigurationProgramSurround0LwRwLhRh_0 writePCMChannelConfigurationProgramSurround0X_0(0x05)
#define writePCMChannelConfigurationProgramSurround1X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0009,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround1LwRw_0 writePCMChannelConfigurationProgramSurround1X_0(0x01)
#define writePCMChannelConfigurationProgramSurround1LhRh_0 writePCMChannelConfigurationProgramSurround1X_0(0x04)
#define writePCMChannelConfigurationProgramSurround1LwRwLhRh_0 writePCMChannelConfigurationProgramSurround1X_0(0x05)
#define writePCMChannelConfigurationProgramSurround2X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRw_0 writePCMChannelConfigurationProgramSurround2X_0(0x01)
#define writePCMChannelConfigurationProgramSurround2LhRh_0 writePCMChannelConfigurationProgramSurround2X_0(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRh_0 writePCMChannelConfigurationProgramSurround2X_0(0x05)
#define writePCMChannelConfigurationProgramSurround2XStereo_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwStereo_0 writePCMChannelConfigurationProgramSurround2XStereo_0(0x01)
#define writePCMChannelConfigurationProgramSurround2LhRhStereo_0 writePCMChannelConfigurationProgramSurround2XStereo_0(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhStereo_0 writePCMChannelConfigurationProgramSurround2XStereo_0(0x05)
#define writePCMChannelConfigurationProgramSurround2XLtRt_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwLtRt_0 writePCMChannelConfigurationProgramSurround2XLtRt_0(0x01) 
#define writePCMChannelConfigurationProgramSurround2LhRhLtRt_0 writePCMChannelConfigurationProgramSurround2XLtRt_0(0x04) 
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhLtRt_0 writePCMChannelConfigurationProgramSurround2XLtRt_0(0x05) 
#define writePCMChannelConfigurationProgramSurround2XMono_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwMono_0 writePCMChannelConfigurationProgramSurround2XMono_0(0x01) 
#define writePCMChannelConfigurationProgramSurround2LhRhMono_0 writePCMChannelConfigurationProgramSurround2XMono_0(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhMono_0 writePCMChannelConfigurationProgramSurround2XMono_0(0x05) 
#define writePCMChannelConfigurationProgramSurround3X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000b,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround3LwRw_0 writePCMChannelConfigurationProgramSurround3X_0(0x01)
#define writePCMChannelConfigurationProgramSurround3LhRh_0 writePCMChannelConfigurationProgramSurround3X_0(0x04)
#define writePCMChannelConfigurationProgramSurround3LwRwLhRh_0 writePCMChannelConfigurationProgramSurround3X_0(0x05)
#define writePCMChannelConfigurationProgramSurround4X_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000c,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround4LwRw_0 writePCMChannelConfigurationProgramSurround4X_0(0x01)
#define writePCMChannelConfigurationProgramSurround4LhRh_0 writePCMChannelConfigurationProgramSurround4X_0(0x04)
#define writePCMChannelConfigurationProgramSurround4LwRwLhRh_0 writePCMChannelConfigurationProgramSurround4X_0(0x05)

// _1
#define writePCMChannelConfigurationProgramNoneX_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0101,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramNoneLwRw_1 writePCMChannelConfigurationProgramNoneX_1(0x01)
#define writePCMChannelConfigurationProgramNoneLhRh_1 writePCMChannelConfigurationProgramNoneX_1(0x04)
#define writePCMChannelConfigurationProgramNoneLwRwLhRh_1 writePCMChannelConfigurationProgramNoneX_1(0x05)
#define writePCMChannelConfigurationProgramMonoX_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0102,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramMonoLwRw_1 writePCMChannelConfigurationProgramMonoX_1(0x01)
#define writePCMChannelConfigurationProgramMonoLhRh_1 writePCMChannelConfigurationProgramMonoX_1(0x04)
#define writePCMChannelConfigurationProgramMonoLwRwLhRh_1 writePCMChannelConfigurationProgramMonoX_1(0x05)
#define writePCMChannelConfigurationProgramPhantom0X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0103,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRw_1 writePCMChannelConfigurationProgramPhantom0X_1(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRh_1 writePCMChannelConfigurationProgramPhantom0X_1(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRh_1 writePCMChannelConfigurationProgramPhantom0X_1(0x05)
#define writePCMChannelConfigurationProgramPhantom0XStereo_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0103,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwStereo_1 writePCMChannelConfigurationProgramPhantom0XStereo_1(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhStereo_1 writePCMChannelConfigurationProgramPhantom0XStereo_1(0x04) 
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhStereo_1 writePCMChannelConfigurationProgramPhantom0XStereo_1(0x05) 
#define writePCMChannelConfigurationProgramPhantom0XLtRt_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0103,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwLtRt_1 writePCMChannelConfigurationProgramPhantom0XLtRt_1(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhLtRt_1 writePCMChannelConfigurationProgramPhantom0XLtRt_1(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhLtRt_1 writePCMChannelConfigurationProgramPhantom0XLtRt_1(0x05)
#define writePCMChannelConfigurationProgramPhantom0XMono_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0103,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwMono_1 writePCMChannelConfigurationProgramPhantom0XMono_1(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhMono_1 writePCMChannelConfigurationProgramPhantom0XMono_1(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhMono_1 writePCMChannelConfigurationProgramPhantom0XMono_1(0x05)
#define writePCMChannelConfigurationProgramPhantom0XDual_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0103,((n<<8)|0x0004),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwDual_1 writePCMChannelConfigurationProgramPhantom0XDual_1(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhDual_1 writePCMChannelConfigurationProgramPhantom0XDual_1(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhDual_1 writePCMChannelConfigurationProgramPhantom0XDual_1(0x05)
#define writePCMChannelConfigurationProgramPhantom1X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0104,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom1LwRw_1 writePCMChannelConfigurationProgramPhantom1X_1(0x01)
#define writePCMChannelConfigurationProgramPhantom1LhRh_1 writePCMChannelConfigurationProgramPhantom1X_1(0x04)
#define writePCMChannelConfigurationProgramPhantom1LwRwLhRh_1 writePCMChannelConfigurationProgramPhantom1X_1(0x05)
#define writePCMChannelConfigurationProgramPhantom2X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0105,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRw_1 writePCMChannelConfigurationProgramPhantom2X_1(0x01)
#define writePCMChannelConfigurationProgramPhantom2LhRh_1 writePCMChannelConfigurationProgramPhantom2X_1(0x04)
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRh_1 writePCMChannelConfigurationProgramPhantom2X_1(0x05)
#define writePCMChannelConfigurationProgramPhantom2XStereo_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0105,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwStereo_1 writePCMChannelConfigurationProgramPhantom2XStereo_1(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhStereo_1 writePCMChannelConfigurationProgramPhantom2XStereo_1(0x04) 
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhStereo_1 writePCMChannelConfigurationProgramPhantom2XStereo_1(0x05) 
#define writePCMChannelConfigurationProgramPhantom2XLtRt_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0105,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwLtRt_1 writePCMChannelConfigurationProgramPhantom2XLtRt_1(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhLtRt_1 writePCMChannelConfigurationProgramPhantom2XLtRt_1(0x04) 
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhLtRt_1 writePCMChannelConfigurationProgramPhantom2XLtRt_1(0x05) 
#define writePCMChannelConfigurationProgramPhantom2XMono_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0105,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwMono_1 writePCMChannelConfigurationProgramPhantom2XMono_1(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhMono_1 writePCMChannelConfigurationProgramPhantom2XMono_1(0x04)
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhMono_1 writePCMChannelConfigurationProgramPhantom2XMono_1(0x05) 
#define writePCMChannelConfigurationProgramPhantom3X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0106,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom3LwRw_1 writePCMChannelConfigurationProgramPhantom3X_1(0x01)
#define writePCMChannelConfigurationProgramPhantom3LhRh_1 writePCMChannelConfigurationProgramPhantom3X_1(0x04)
#define writePCMChannelConfigurationProgramPhantom3LwRwLhRh_1 writePCMChannelConfigurationProgramPhantom3X_1(0x05)
#define writePCMChannelConfigurationProgramPhantom4X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0107,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom4LwRw_1 writePCMChannelConfigurationProgramPhantom4X_1(0x01)
#define writePCMChannelConfigurationProgramPhantom4LhRh_1 writePCMChannelConfigurationProgramPhantom4X_1(0x04)
#define writePCMChannelConfigurationProgramPhantom4LwRwLhRh_1 writePCMChannelConfigurationProgramPhantom4X_1(0x05)
#define writePCMChannelConfigurationProgramSurround0X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0108,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround0LwRw_1 writePCMChannelConfigurationProgramSurround0X_1(0x01)
#define writePCMChannelConfigurationProgramSurround0LhRh_1 writePCMChannelConfigurationProgramSurround0X_1(0x04)
#define writePCMChannelConfigurationProgramSurround0LwRwLhRh_1 writePCMChannelConfigurationProgramSurround0X_1(0x05)
#define writePCMChannelConfigurationProgramSurround1X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0109,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround1LwRw_1 writePCMChannelConfigurationProgramSurround1X_1(0x01)
#define writePCMChannelConfigurationProgramSurround1LhRh_1 writePCMChannelConfigurationProgramSurround1X_1(0x04)
#define writePCMChannelConfigurationProgramSurround1LwRwLhRh_1 writePCMChannelConfigurationProgramSurround1X_1(0x05)
#define writePCMChannelConfigurationProgramSurround2X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRw_1 writePCMChannelConfigurationProgramSurround2X_1(0x01)
#define writePCMChannelConfigurationProgramSurround2LhRh_1 writePCMChannelConfigurationProgramSurround2X_1(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRh_1 writePCMChannelConfigurationProgramSurround2X_1(0x05)
#define writePCMChannelConfigurationProgramSurround2XStereo_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwStereo_1 writePCMChannelConfigurationProgramSurround2XStereo_1(0x01)
#define writePCMChannelConfigurationProgramSurround2LhRhStereo_1 writePCMChannelConfigurationProgramSurround2XStereo_1(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhStereo_1 writePCMChannelConfigurationProgramSurround2XStereo_1(0x05)
#define writePCMChannelConfigurationProgramSurround2XLtRt_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwLtRt_1 writePCMChannelConfigurationProgramSurround2XLtRt_1(0x01) 
#define writePCMChannelConfigurationProgramSurround2LhRhLtRt_1 writePCMChannelConfigurationProgramSurround2XLtRt_1(0x04) 
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhLtRt_1 writePCMChannelConfigurationProgramSurround2XLtRt_1(0x05) 
#define writePCMChannelConfigurationProgramSurround2XMono_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwMono_1 writePCMChannelConfigurationProgramSurround2XMono_1(0x01) 
#define writePCMChannelConfigurationProgramSurround2LhRhMono_1 writePCMChannelConfigurationProgramSurround2XMono_1(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhMono_1 writePCMChannelConfigurationProgramSurround2XMono_1(0x05) 
#define writePCMChannelConfigurationProgramSurround3X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010b,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround3LwRw_1 writePCMChannelConfigurationProgramSurround3X_1(0x01)
#define writePCMChannelConfigurationProgramSurround3LhRh_1 writePCMChannelConfigurationProgramSurround3X_1(0x04)
#define writePCMChannelConfigurationProgramSurround3LwRwLhRh_1 writePCMChannelConfigurationProgramSurround3X_1(0x05)
#define writePCMChannelConfigurationProgramSurround4X_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010c,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround4LwRw_1 writePCMChannelConfigurationProgramSurround4X_1(0x01)
#define writePCMChannelConfigurationProgramSurround4LhRh_1 writePCMChannelConfigurationProgramSurround4X_1(0x04)
#define writePCMChannelConfigurationProgramSurround4LwRwLhRh_1 writePCMChannelConfigurationProgramSurround4X_1(0x05)
// _2
#define writePCMChannelConfigurationProgramNoneX_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0201,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramNoneLwRw_2 writePCMChannelConfigurationProgramNoneX_2(0x01)
#define writePCMChannelConfigurationProgramNoneLhRh_2 writePCMChannelConfigurationProgramNoneX_2(0x04)
#define writePCMChannelConfigurationProgramNoneLwRwLhRh_2 writePCMChannelConfigurationProgramNoneX_2(0x05)
#define writePCMChannelConfigurationProgramMonoX_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0202,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramMonoLwRw_2 writePCMChannelConfigurationProgramMonoX_2(0x01)
#define writePCMChannelConfigurationProgramMonoLhRh_2 writePCMChannelConfigurationProgramMonoX_2(0x04)
#define writePCMChannelConfigurationProgramMonoLwRwLhRh_2 writePCMChannelConfigurationProgramMonoX_2(0x05)
#define writePCMChannelConfigurationProgramPhantom0X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0203,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRw_2 writePCMChannelConfigurationProgramPhantom0X_2(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRh_2 writePCMChannelConfigurationProgramPhantom0X_2(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRh_2 writePCMChannelConfigurationProgramPhantom0X_2(0x05)
#define writePCMChannelConfigurationProgramPhantom0XStereo_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0203,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwStereo_2 writePCMChannelConfigurationProgramPhantom0XStereo_2(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhStereo_2 writePCMChannelConfigurationProgramPhantom0XStereo_2(0x04) 
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhStereo_2 writePCMChannelConfigurationProgramPhantom0XStereo_2(0x05) 
#define writePCMChannelConfigurationProgramPhantom0XLtRt_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0203,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwLtRt_2 writePCMChannelConfigurationProgramPhantom0XLtRt_2(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhLtRt_2 writePCMChannelConfigurationProgramPhantom0XLtRt_2(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhLtRt_2 writePCMChannelConfigurationProgramPhantom0XLtRt_2(0x05)
#define writePCMChannelConfigurationProgramPhantom0XMono_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0203,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwMono_2 writePCMChannelConfigurationProgramPhantom0XMono_2(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhMono_2 writePCMChannelConfigurationProgramPhantom0XMono_2(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhMono_2 writePCMChannelConfigurationProgramPhantom0XMono_2(0x05)
#define writePCMChannelConfigurationProgramPhantom0XDual_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0203,((n<<8)|0x0004),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom0LwRwDual_2 writePCMChannelConfigurationProgramPhantom0XDual_2(0x01)
#define writePCMChannelConfigurationProgramPhantom0LhRhDual_2 writePCMChannelConfigurationProgramPhantom0XDual_2(0x04)
#define writePCMChannelConfigurationProgramPhantom0LwRwLhRhDual_2 writePCMChannelConfigurationProgramPhantom0XDual_2(0x05)
#define writePCMChannelConfigurationProgramPhantom1X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0204,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom1LwRw_2 writePCMChannelConfigurationProgramPhantom1X_2(0x01)
#define writePCMChannelConfigurationProgramPhantom1LhRh_2 writePCMChannelConfigurationProgramPhantom1X_2(0x04)
#define writePCMChannelConfigurationProgramPhantom1LwRwLhRh_2 writePCMChannelConfigurationProgramPhantom1X_2(0x05)
#define writePCMChannelConfigurationProgramPhantom2X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0205,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRw_2 writePCMChannelConfigurationProgramPhantom2X_2(0x01)
#define writePCMChannelConfigurationProgramPhantom2LhRh_2 writePCMChannelConfigurationProgramPhantom2X_2(0x04)
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRh_2 writePCMChannelConfigurationProgramPhantom2X_2(0x05)
#define writePCMChannelConfigurationProgramPhantom2XStereo_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0205,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwStereo_2 writePCMChannelConfigurationProgramPhantom2XStereo_2(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhStereo_2 writePCMChannelConfigurationProgramPhantom2XStereo_2(0x04) 
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhStereo_2 writePCMChannelConfigurationProgramPhantom2XStereo_2(0x05) 
#define writePCMChannelConfigurationProgramPhantom2XLtRt_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0205,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwLtRt_2 writePCMChannelConfigurationProgramPhantom2XLtRt_2(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhLtRt_2 writePCMChannelConfigurationProgramPhantom2XLtRt_2(0x04) 
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhLtRt_2 writePCMChannelConfigurationProgramPhantom2XLtRt_2(0x05) 
#define writePCMChannelConfigurationProgramPhantom2XMono_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0205,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom2LwRwMono_2 writePCMChannelConfigurationProgramPhantom2XMono_2(0x01) 
#define writePCMChannelConfigurationProgramPhantom2LhRhMono_2 writePCMChannelConfigurationProgramPhantom2XMono_2(0x04)
#define writePCMChannelConfigurationProgramPhantom2LwRwLhRhMono_2 writePCMChannelConfigurationProgramPhantom2XMono_2(0x05) 
#define writePCMChannelConfigurationProgramPhantom3X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0206,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom3LwRw_2 writePCMChannelConfigurationProgramPhantom3X_2(0x01)
#define writePCMChannelConfigurationProgramPhantom3LhRh_2 writePCMChannelConfigurationProgramPhantom3X_2(0x04)
#define writePCMChannelConfigurationProgramPhantom3LwRwLhRh_2 writePCMChannelConfigurationProgramPhantom3X_2(0x05)
#define writePCMChannelConfigurationProgramPhantom4X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0207,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramPhantom4LwRw_2 writePCMChannelConfigurationProgramPhantom4X_2(0x01)
#define writePCMChannelConfigurationProgramPhantom4LhRh_2 writePCMChannelConfigurationProgramPhantom4X_2(0x04)
#define writePCMChannelConfigurationProgramPhantom4LwRwLhRh_2 writePCMChannelConfigurationProgramPhantom4X_2(0x05)
#define writePCMChannelConfigurationProgramSurround0X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0208,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround0LwRw_2 writePCMChannelConfigurationProgramSurround0X_2(0x01)
#define writePCMChannelConfigurationProgramSurround0LhRh_2 writePCMChannelConfigurationProgramSurround0X_2(0x04)
#define writePCMChannelConfigurationProgramSurround0LwRwLhRh_2 writePCMChannelConfigurationProgramSurround0X_2(0x05)
#define writePCMChannelConfigurationProgramSurround1X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0209,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround1LwRw_2 writePCMChannelConfigurationProgramSurround1X_2(0x01)
#define writePCMChannelConfigurationProgramSurround1LhRh_2 writePCMChannelConfigurationProgramSurround1X_2(0x04)
#define writePCMChannelConfigurationProgramSurround1LwRwLhRh_2 writePCMChannelConfigurationProgramSurround1X_2(0x05)
#define writePCMChannelConfigurationProgramSurround2X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRw_2 writePCMChannelConfigurationProgramSurround2X_2(0x01)
#define writePCMChannelConfigurationProgramSurround2LhRh_2 writePCMChannelConfigurationProgramSurround2X_2(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRh_2 writePCMChannelConfigurationProgramSurround2X_2(0x05)
#define writePCMChannelConfigurationProgramSurround2XStereo_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,((n<<8)|0x0001),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwStereo_2 writePCMChannelConfigurationProgramSurround2XStereo_2(0x01)
#define writePCMChannelConfigurationProgramSurround2LhRhStereo_2 writePCMChannelConfigurationProgramSurround2XStereo_2(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhStereo_2 writePCMChannelConfigurationProgramSurround2XStereo_2(0x05)
#define writePCMChannelConfigurationProgramSurround2XLtRt_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,((n<<8)|0x0002),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwLtRt_2 writePCMChannelConfigurationProgramSurround2XLtRt_2(0x01) 
#define writePCMChannelConfigurationProgramSurround2LhRhLtRt_2 writePCMChannelConfigurationProgramSurround2XLtRt_2(0x04) 
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhLtRt_2 writePCMChannelConfigurationProgramSurround2XLtRt_2(0x05) 
#define writePCMChannelConfigurationProgramSurround2XMono_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,((n<<8)|0x0003),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwMono_2 writePCMChannelConfigurationProgramSurround2XMono_2(0x01) 
#define writePCMChannelConfigurationProgramSurround2LhRhMono_2 writePCMChannelConfigurationProgramSurround2XMono_2(0x04)
#define writePCMChannelConfigurationProgramSurround2LwRwLhRhMono_2 writePCMChannelConfigurationProgramSurround2XMono_2(0x05) 
#define writePCMChannelConfigurationProgramSurround3X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020b,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround3LwRw_2 writePCMChannelConfigurationProgramSurround3X_2(0x01)
#define writePCMChannelConfigurationProgramSurround3LhRh_2 writePCMChannelConfigurationProgramSurround3X_2(0x04)
#define writePCMChannelConfigurationProgramSurround3LwRwLhRh_2 writePCMChannelConfigurationProgramSurround3X_2(0x05)
#define writePCMChannelConfigurationProgramSurround4X_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020c,(n<<8),0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround4LwRw_2 writePCMChannelConfigurationProgramSurround4X_2(0x01)
#define writePCMChannelConfigurationProgramSurround4LhRh_2 writePCMChannelConfigurationProgramSurround4X_2(0x04)
#define writePCMChannelConfigurationProgramSurround4LwRwLhRh_2 writePCMChannelConfigurationProgramSurround4X_2(0x05)

// sort of legacy.  Only writes the low 32 bits.
// #define writePCMChannelConfigurationProgramHL(HH,LL) 0xcc00+STD_BETA_PCM,0x001C,LL,HH
#define writePCMChannelConfigurationProgramHL(HH,LL) 0xce00+STD_BETA_PCM,0x1808,LL,HH,0,0

// writes the full 64 bits
#define writePCMExtChannelConfigurationProgramHLHL(HH,HL,LH,LL) 0xce00+STD_BETA_PCM,0x1808,LL,LH,HL,HH

#define  readPCMChannelConfigurationProgramExtChan         0xc200+STD_BETA_PCM,0x0b00
#define  readPCMChannelConfigurationProgramExtMask         readPCMChannelConfigurationProgramExtChan
#define writePCMChannelConfigurationProgramExtChanNone     0xca00+STD_BETA_PCM,0x0b00
#define writePCMChannelConfigurationProgramExtChanLhRh     0xca00+STD_BETA_PCM,(0x0b04)//PAF_CC_EXTMASK_LhRh
#define writePCMChannelConfigurationProgramExtChanLwRw     0xca00+STD_BETA_PCM,(0x0b01)//PAF_CC_EXTMASK_LwRw
#define writePCMChannelConfigurationProgramExtChanLhRhLwRw 0xca00+STD_BETA_PCM,(0x0b05)//PAF_CC_EXTMASK_LhRh|PAF_CC_EXTMASK_LwRw

#define writePCMChannelConfigurationProgramAuxUnknown 0xca00+STD_BETA_PCM,0x0a00
#define writePCMChannelConfigurationProgramAuxStereo 0xca00+STD_BETA_PCM,0x0a01
#define writePCMChannelConfigurationProgramAuxLtRt 0xca00+STD_BETA_PCM,0x0a02
#define writePCMChannelConfigurationProgramAuxMono 0xca00+STD_BETA_PCM,0x0a03
#define writePCMChannelConfigurationProgramAuxDual 0xca00+STD_BETA_PCM,0x0a04

//ATMOS
#define writePCMChannelConfigurationProgramSurround2ATMOS_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0000,(n<<8),0x0000
#define writePCMChannelConfigurationProgramSurround2ATMOS_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0000,(n<<8),0x0000
#define writePCMChannelConfigurationProgramSurround2ATMOS_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0000,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround2ATMOSMono_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0003,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround2ATMOSMono_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0003,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround2ATMOSMono_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0003,(n<<8),0x0000

#define writePCMChannelConfigurationProgramSurround2LwRwATMOS_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0100,(n<<8),0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwATMOS_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0100,(n<<8),0x0000
#define writePCMChannelConfigurationProgramSurround2LwRwATMOS_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0100,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround2LwRwATMOSMono_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0103,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround2LwRwATMOSMono_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0103,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround2LwRwATMOSMono_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0103,(n<<8),0x0000

#define writePCMChannelConfigurationProgramSurround4ATMOS_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000c,0x0000,(n<<8),0x0000
#define writePCMChannelConfigurationProgramSurround4ATMOS_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010c,0x0000,(n<<8),0x0000
#define writePCMChannelConfigurationProgramSurround4ATMOS_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020c,0x0000,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround4ATMOSMono_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000c,0x0003,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround4ATMOSMono_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010c,0x0003,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround4ATMOSMono_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020c,0x0003,(n<<8),0x0000

#define writePCMChannelConfigurationProgramSurround4LwRwATMOS_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000a,0x0100,(n<<8),0x0000
#define writePCMChannelConfigurationProgramSurround4LwRwATMOS_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0100,(n<<8),0x0000
#define writePCMChannelConfigurationProgramSurround4LwRwATMOS_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020a,0x0100,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround4LwRwATMOSMono_0(n) 0xce00+STD_BETA_PCM,0x1808,0x000c,0x0103,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround4LwRwATMOSMono_1(n) 0xce00+STD_BETA_PCM,0x1808,0x010c,0x0103,(n<<8),0x0000
#define wrotePCMChannelConfigurationProgramSurround4LwRwATMOSMono_2(n) 0xce00+STD_BETA_PCM,0x1808,0x020c,0x0103,(n<<8),0x0000

#define writePCMChannelConfigurationProgramSurround2LtfRtfLtrRtr_0 writePCMChannelConfigurationProgramSurround2ATMOS_0(0xA)
#define writePCMChannelConfigurationProgramSurround2LtfRtfLtrRtr_1 writePCMChannelConfigurationProgramSurround2ATMOS_1(0xA)
#define writePCMChannelConfigurationProgramSurround2LtfRtfLtrRtr_2 writePCMChannelConfigurationProgramSurround2ATMOS_2(0xA)
#define wrotePCMChannelConfigurationProgramSurround2LtfRtfLtrRtr_0 wrotePCMChannelConfigurationProgramSurround2ATMOSMono_0(0xA)
#define wrotePCMChannelConfigurationProgramSurround2LtfRtfLtrRtr_1 wrotePCMChannelConfigurationProgramSurround2ATMOSMono_1(0xA)
#define wrotePCMChannelConfigurationProgramSurround2LtfRtfLtrRtr_2 wrotePCMChannelConfigurationProgramSurround2ATMOSMono_2(0xA)

#define writePCMChannelConfigurationProgramSurround4LtmRtm_0 writePCMChannelConfigurationProgramSurround4ATMOS_0(0x4)
#define writePCMChannelConfigurationProgramSurround4LtmRtm_1 writePCMChannelConfigurationProgramSurround4ATMOS_1(0x4)
#define writePCMChannelConfigurationProgramSurround4LtmRtm_2 writePCMChannelConfigurationProgramSurround4ATMOS_2(0x4)
#define wrotePCMChannelConfigurationProgramSurround4LtmRtm_0 wrotePCMChannelConfigurationProgramSurround4ATMOSMono_0(0x4)
#define wrotePCMChannelConfigurationProgramSurround4LtmRtm_1 wrotePCMChannelConfigurationProgramSurround4ATMOSMono_1(0x4)
#define wrotePCMChannelConfigurationProgramSurround4LtmRtm_2 wrotePCMChannelConfigurationProgramSurround4ATMOSMono_2(0x4)

#define writePCMChannelConfigurationProgramSurround2LwRwLtfRtfLtrRtr_0 writePCMChannelConfigurationProgramSurround2LwRwATMOS_0(0xA)
#define writePCMChannelConfigurationProgramSurround2LwRwLtfRtfLtrRtr_1 writePCMChannelConfigurationProgramSurround2LwRwATMOS_1(0xA)
#define writePCMChannelConfigurationProgramSurround2LwRwLtfRtfLtrRtr_2 writePCMChannelConfigurationProgramSurround2LwRwATMOS_2(0xA)
#define wrotePCMChannelConfigurationProgramSurround2LwRwLtfRtfLtrRtr_0 wrotePCMChannelConfigurationProgramSurround2LwRwATMOSMono_0(0xA)
#define wrotePCMChannelConfigurationProgramSurround2LwRwLtfRtfLtrRtr_1 wrotePCMChannelConfigurationProgramSurround2LwRwATMOSMono_1(0xA)
#define wrotePCMChannelConfigurationProgramSurround2LwRwLtfRtfLtrRtr_2 wrotePCMChannelConfigurationProgramSurround2LwRwATMOSMono_2(0xA)

#define writePCMChannelConfigurationProgramSurround4LtfRtfLtrRtr_0 writePCMChannelConfigurationProgramSurround4ATMOS_0(0xA)
#define writePCMChannelConfigurationProgramSurround4LtfRtfLtrRtr_1 writePCMChannelConfigurationProgramSurround4ATMOS_1(0xA)
#define writePCMChannelConfigurationProgramSurround4LtfRtfLtrRtr_2 writePCMChannelConfigurationProgramSurround4ATMOS_2(0xA)
#define wrotePCMChannelConfigurationProgramSurround4LtfRtfLtrRtr_0 wrotePCMChannelConfigurationProgramSurround4ATMOSMono_0(0xA)
#define wrotePCMChannelConfigurationProgramSurround4LtfRtfLtrRtr_1 wrotePCMChannelConfigurationProgramSurround4ATMOSMono_1(0xA)
#define wrotePCMChannelConfigurationProgramSurround4LtfRtfLtrRtr_2 wrotePCMChannelConfigurationProgramSurround4ATMOSMono_2(0xA)

#define writePCMChannelConfigurationProgramSurround4LwRwLtfRtfLtrRtr_0 writePCMChannelConfigurationProgramSurround4LwRwATMOS_0(0xA)
#define writePCMChannelConfigurationProgramSurround4LwRwLtfRtfLtrRtr_1 writePCMChannelConfigurationProgramSurround4LwRwATMOS_1(0xA)
#define writePCMChannelConfigurationProgramSurround4LwRwLtfRtfLtrRtr_2 writePCMChannelConfigurationProgramSurround4LwRwATMOS_2(0xA)
#define wrotePCMChannelConfigurationProgramSurround4LwRwLtfRtfLtrRtr_0 wrotePCMChannelConfigurationProgramSurround4LwRwATMOSMono_0(0xA)
#define wrotePCMChannelConfigurationProgramSurround4LwRwLtfRtfLtrRtr_1 wrotePCMChannelConfigurationProgramSurround4LwRwATMOSMono_1(0xA)
#define wrotePCMChannelConfigurationProgramSurround4LwRwLtfRtfLtrRtr_2 wrotePCMChannelConfigurationProgramSurround4LwRwATMOSMono_2(0xA)

#define writePCMChannelConfigurationProgramPhantom4LwRwATMOS_0(n) 0xce00+STD_BETA_PCM,0x1808,0x0007,0x0100,(n<<8),0x0000
#define writePCMChannelConfigurationProgramPhantom4LwRwATMOS_1(n) 0xce00+STD_BETA_PCM,0x1808,0x0107,0x0100,(n<<8),0x0000
#define writePCMChannelConfigurationProgramPhantom4LwRwATMOS_2(n) 0xce00+STD_BETA_PCM,0x1808,0x0207,0x0100,(n<<8),0x0000
#define writePCMChannelConfigurationProgramPhantom4LwRwLctRct_0 writePCMChannelConfigurationProgramPhantom4LwRwATMOS_0(0x20)
#define writePCMChannelConfigurationProgramPhantom4LwRwLctRct_1 writePCMChannelConfigurationProgramPhantom4LwRwATMOS_1(0x20)
#define writePCMChannelConfigurationProgramPhantom4LwRwLctRct_2 writePCMChannelConfigurationProgramPhantom4LwRwATMOS_2(0x20)
#define writePCMChannelConfigurationProgramPhantom4LwRwLtfRtfLtmRtmLctRct_0 writePCMChannelConfigurationProgramPhantom4LwRwATMOS_0(0x26)
#define writePCMChannelConfigurationProgramPhantom4LwRwLtfRtfLtmRtmLctRct_1 writePCMChannelConfigurationProgramPhantom4LwRwATMOS_1(0x26)
#define writePCMChannelConfigurationProgramPhantom4LwRwLtfRtfLtmRtmLctRct_2 writePCMChannelConfigurationProgramPhantom4LwRwATMOS_2(0x26)

// Reference: pafcc.h: PAFCC_SIX_CHANNEL_CONFIG_FULL "5.1" 6 channel config
// PAF_ChannelConfiguration [sub][sat],[extMask][aux],[extMask3][extMask2],[reserved2][reserved1]
// PAF_ChannelConfiguration 0x010a,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround2_5_1 0xce00+STD_BETA_PCM,0x1808,0x010a,0x0000,0x0000,0x0000

// Reference: pafcc.h: PAFCC_EIGHT_CHANNEL_CONFIG_FULL "7.1" 8 channel config
// PAF_ChannelConfiguration [sub][sat],[extMask][aux],[extMask3][extMask2],[reserved2][reserved1]
// PAF_ChannelConfiguration 0x010c,0x0000,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround4_7_1 0xce00+STD_BETA_PCM,0x1808,0x010c,0x0000,0x0000,0x0000

// Reference: pafcc.h: PAFCC_TWELVE_CHANNEL_ATMOS_CONFIG_FULL "11.1" 12 channel mask (ATMOS version)
// PAF_LEFT,PAF_RGHT,PAF_CNTR,PAF_LTRR,PAF_RTRR,PAF_LSUR,PAF_RSUR,PAF_LBAK,PAF_RBAK,PAF_SUBW,PAF_LTFT,PAF_RTFT,
// PAF_ChannelConfiguration [sub][sat],[extMask][aux],[extMask3][extMask2],[reserved2][reserved1]
// PAF_ChannelConfiguration 0x010c,0x0000,0x0a00,0x0000
#define writePCMChannelConfigurationProgramSurround4LtfRtfLtrRtr_11_1 writePCMChannelConfigurationProgramSurround4LtfRtfLtrRtr_1

// Reference: pafcc.h: PAFCC_TWELVE_CHANNEL_CONFIG_FULL "11.1" 12 channel mask (non ATMOS version)
// PAF_LEFT,PAF_RGHT,PAF_CNTR,PAF_LWID,PAF_RWID,PAF_LSUR,PAF_RSUR,PAF_LBAK,PAF_RBAK,PAF_SUBW,PAF_LHED,PAF_RHED
// PAF_ChannelConfiguration [sub][sat],[extMask][aux],[extMask3][extMask2],[reserved2][reserved1]
// PAF_ChannelConfiguration 0x010c,0x0500,0x0000,0x0000
#define writePCMChannelConfigurationProgramSurround4LhRhLwRw_11_1 0xce00+STD_BETA_PCM,0x1808,0x010c,0x0500,0x0000,0x0000
 
// Reference: pafcc.h: PAFCC_SIXTEEN_CHANNEL_CONFIG_FULL "14.2" 14 channel mask
// PAF_ChannelConfiguration [sub][sat],[extMask][aux],[extMask3][extMask2],[reserved2][reserved1]
// PAF_ChannelConfiguration 0x0207,0x0100,0x2600,0x0000
#define writePCMChannelConfigurationProgramPhantom4LwRwLtfRtfLtmRtmLctRct_14_2 writePCMChannelConfigurationProgramPhantom4LwRwLtfRtfLtmRtmLctRct_2
#define writePCMChannelConfigurationProgram16Channels writePCMChannelConfigurationProgramPhantom4LwRwLtfRtfLtmRtmLctRct_14_2

// Reference: pafcc.h: PAFCC_THIRTYTWO_CHANNEL_CONFIG_FULL 32 channel mask
// PAF_ChannelConfiguration [sub][sat],[extMask][aux],[extMask3][extMask2],[reserved2][reserved1]
// PAF_ChannelConfiguration 0x0207,0x0100,0xe67f,0x0000
#define writePCMChannelConfigurationProgramPhantom4LwRwLtfRtfLtmRtmLctRctLhbkRhbkChbk_30_2 0xce00+STD_BETA_PCM,0x1808,0x0207,0x0100,0xe67f,0x0000
// Obsolete: #define writePCMChannelConfigurationProgram32Channels 0xce00+STD_BETA_PCM,0x1808,0x020c,0xff00,0x3fff,0x0000
#define writePCMChannelConfigurationProgram32Channels writePCMChannelConfigurationProgramPhantom4LwRwLtfRtfLtmRtmLctRctLhbkRhbkChbk_30_2

#define readPCMChannelConfigurationProgramATMOSChan         0xc200+STD_BETA_PCM,0x3d00
#define readPCMChannelConfigurationProgramATMOSMask         readPCMChannelConfigurationProgramATMOSChan
#define writePCMChannelConfigurationProgramATMOSChanNone     0xca00+STD_BETA_PCM,0x3d00
#define writePCMChannelConfigurationProgramATMOSChanLfhRfhLrhRrh     0xca00+STD_BETA_PCM,(0x3d11)//PAF_CC_EXTMASK_LfhRfh|PAF_CC_EXTMASK_LrhRrh
#define writePCMChannelConfigurationProgramATMOSChanLtfRtfLtrRtr     0xca00+STD_BETA_PCM,(0x3d0a)//PAF_CC_EXTMASK_LtfRtf|PAF_CC_EXTMASK_LtrRtr
#define writePCMChannelConfigurationProgramATMOSChanLtmRtm 0xca00+STD_BETA_PCM,(0x3d04)//PAF_CC_EXTMASK_LtmRtm

//-------------------------------------------------------------------------------------------------------------
#define  readPCMCenterMixLevel 0xc300+STD_BETA_PCM,0x000C
#define writePCMCenterMixLevelN(NN) 0xcb00+STD_BETA_PCM,0x000C,(0xFFFF&(NN))
#define wrotePCMCenterMixLevel 0xcb00+STD_BETA_PCM,0x000C

#define  readPCMSurroundMixLevel 0xc300+STD_BETA_PCM,0x000E
#define writePCMSurroundMixLevelN(NN) 0xcb00+STD_BETA_PCM,0x000E,(0xFFFF&(NN))
#define wrotePCMSurroundMixLevel 0xcb00+STD_BETA_PCM,0x000E

#define  readPCMLFEDownmixInclude 0xc200+STD_BETA_PCM,0x1000
#define writePCMLFEDownmixIncludeNo 0xca00+STD_BETA_PCM,0x1000
#define writePCMLFEDownmixIncludeYes 0xca00+STD_BETA_PCM,0x1001


#define  readPCMStatus 0xc508,STD_BETA_PCM
#define  readPCMControl \
         readPCMMode, \
         readPCMRamp, \
         readPCMScaleVolume, \
         readPCMLFEDownmixVolume, \
         readPCMChannelConfigurationProgram, \
         readPCMCenterMixLevel, \
         readPCMSurroundMixLevel, \
         readPCMLFEDownmixInclude         

#endif /* _PCM_A */

